% Find the nearest neighbors to the discords in the main memory. In the
% process remove elements that cannot be discords (have neighbors closer
% than the threshold)
% DB - database
% MM - main memory holding the discords
% indxPtr - pointers of the MM to their position in the DB
% offset - actual index taking into account the current DB page
% threshold - discords of interest have neighbors at least that much
% distance away
function [newMM, newindxPtr, newnnDists] = findDiscordNN(DB, MM, indxPtr, nnDists, ...
                                                   threshold, offset)
    earlyAbandon = true;
    znormalize = false;
    for i = 1:size(DB,1)
        j = 1;
        while (j <= size(MM,1))
            if (indxPtr(j) - offset == i) 
                j = j+1;
                continue;
            end;
            tmpDist = computeDist(MM(j,:), DB(i,:)); % todo: use early abandon, store the nn so far to each MM(j)
            if (tmpDist < threshold)
                inds = zeros(size(MM,1), 1);
                inds(j) = 1;
                indsToKeep = find(inds == 0);
                MM = MM(indsToKeep, :);
                indxPtr = indxPtr(indsToKeep,:); 
                nnDists = nnDists(indsToKeep,:);
                continue;
            end;
            if (nnDists(j) > tmpDist)
                nnDists(j) = tmpDist;
            end;
            j = j+1;
        end;
    end;
    newMM = MM;
    newindxPtr = indxPtr;
    newnnDists = nnDists;
